(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

let verbose = ref false;;

let print_rules = ref true;;

let print_stats = ref true;;

open Useful;;

let tset = ref StrSet.empty;;

let trace s = tset := StrSet.add s !tset;;

let untrace s = tset := StrSet.remove s !tset;;

let is_traced s = !verbose && StrSet.mem s !tset;;

open Printf;;

let output_aux fn s func arg =
  printf "%s: %s\n%a" fn s (to_channel func) arg; flush stdout;;

let output fn s func arg =
  if is_traced fn then output_aux fn s func arg;;

let sep_aux () =
  printf "**************************************************************\n";;

let sep () = if !verbose then sep_aux ();;

let output_sep fn s func arg =
  if is_traced fn then (sep_aux (); output_aux fn s func arg);;

let output_string_aux fn s =
  Printf.printf "%s: %s\n" fn s; flush stdout;;

let output_string fn s =
  if is_traced fn then output_string_aux fn s;;

let output_string_sep fn s =
  if is_traced fn then (sep_aux (); output_string_aux fn s);;
