(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* rewrite rules. the variables of the rhs must be included in the lhs *)

open Term;;
open Useful;;

type rule = term * term;;

(* equality up to lhs-variables renaming *)

val compare : rule -> rule -> int;;

(* print an equation *)

val bprint : rule bprint;;

(* useful modules *)

module OrdRul : ORD_PRT;;

module RulSet : Myset.S with type elt = rule;;

(* symbols of a set of rules *)

open Symb;;

val symbols_of_rule : rule -> SymbSet.t;;

val symbols_of_rules : RulSet.t -> SymbSet.t;;
